// -*- mode: cpp; mode: fold -*-
// Description								/*{{{*/
// $Id: utils.cc,v 1.4 1998/01/24 02:54:56 jgg Exp $
/* ######################################################################

   General Utilities.
   
   ###################################################################### */
									/*}}}*/
// Includes								/*{{{*/
#include <deity/utils.h>
#include <deity/graphics.h>

#include <string>
#include <iostream.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

									/*}}}*/

// ReAttachStreams - Reconnects cout, clog and cerr for textmode	/*{{{*/
// ---------------------------------------------------------------------
/* This routine remaps clog to /dev/null or whatever fd 2 is. All debug
   output should go to clog, cout and cerr are left untouched. Outputting
   to cerr/cout will cause problems in text mode if the display isn't restored.
   
   Use something like 'myprog 2> log' in your shell to see the output.
 */
#include <errno.h>
void ReAttachStreams()
{
   // Stderr isnt stdout so we just point clog to cerr.
   string Err;
   if (ttyname(STDERR_FILENO) != 0)
      Err = ttyname(STDERR_FILENO);
   string Out;
   if (ttyname(STDOUT_FILENO) != 0)
      Out = ttyname(STDOUT_FILENO);
   
   // Remap if stderr isnt a fd or if it isnt the same as stdout
   if (Err != Out)
   {
      clog.rdbuf(cerr.rdbuf());
      clog << "Logging initiated" << endl;
      return;
   }
   
                 
   // Dont fiddle with the output in graphics mode
   if (TextGC::GC == 0)
      return;
   
   // We map everything to /dev/null
   int Fd = open("/dev/null",O_WRONLY | O_CREAT | O_TRUNC);
   if (Fd <= 0)
   {
      cerr << "Unable to open /dev/null!" << endl;
      exit(0);
   }

   // Point to the new streambuf at /dev/null
   streambuf *Buf = new filebuf(Fd);
   clog.rdbuf(Buf);
}
									/*}}}*/

